;;;  tcl.var
;;; 04.5.4
;;;  tclѿ
;;;  $m,  $m(a),$m(a,b),....
;;; scheme˰ܿ뤿δؿʤ

(load "GCL")

(define *tcl-vars* ())

(define (force-simplelist v)
  (let* ((a 0)(res ()))
    (while (pair? v)
       (set! a (pop v))
       (if (pair? a)
         (begin
           (set! a (force-simplelist a))
           (while (pair? a)
             (push (pop a) res)
           )
         )
        (push a res)
       )
    )
  (reverse res)
))

;;; intern tcl-var
(define *foo* '("foo"))
(define (tcl-var . v)
     (set! v (force-simplelist v))
     (let* ((x (assoc v *tcl-vars*)))
       (if x x
          (begin
            (set! x (cons v (cons *foo* *foo* )))   ;;;  ()  initial value
                                ;;; "foo" need because assoc may take
                                ;;; other name accidentally for
                                ;;; (s a) if (a) is value of  s 
                                ;;; but mistake  var=(s a) & value ()
            (push x *tcl-vars*)
            x
           )
        )
     )
)

;;;  define  tcl-vars
;;;  No define need!!!
#|
(define-macro (define-tcl-vars . body) 
   (let* ((---temp-tcl-variable--- (car body)))
      (if (null? (cdr body))
          `(define  ,(apply tcl-var  ---temp-tcl-variable---) ())
          `(begin (define-tcl-vars ,---temp-tcl-variable---)
                   (define-tcl-vars ,@(cdr body)))
      )
))
|#
;;;  value
(define ($ . v)
   ;;;(symbol-value (apply tcl-var v))
   (let* ((val (cddr (apply tcl-var v))))
     (if (eq? val *foo*) () val)
  )
)

;;;  setf  see GCL.ss  in sslib
(define-syntax setf
  (syntax-rules (aref nthi $)
    ((setf ($  v ...) val)(set-cdr! (cdr (tcl-var v ...)) val))
    ((setf (aref vec n) val)(vector-set! vec n val))
    ((setf (nth lis n) val)(list-set lis n val))
    ((setf var val)   (set! var val))
  )  
)    

        

(define (join lis)
  (apply  append lis ))

;;;   crazy Tcl list -> ss list
#|
(define (reform-list lis)
  (if (null? lis)
         lis
    (if (pair? lis)
          (if (pair? (car lis)) lis
                 (cons lis ())
          )
       (if (equal? lis "")
           ()
          lis
       )
    )
  )
)

|#

(define (make-list n obj)
   (do ((res ()))
       ((= n 0) res)
       (set! res (cons obj res))
       (set! n (- n 1))
    )
)

(define (list-head lis n)
  (do ((res ()))
      ((= n 0) (reverse res))
      (push (pop lis) res)
      (set! n (- n 1))
  )
)
(define (list-tail lis n)
  (do ()
     ((< n 0) lis)
     (set! lis (cdr lis))
     (set! n (- n 1))
 )
)   
(define (lreplace lis start end . obj)
  (let ((s (list-head lis start))
        (r (list-tail lis end)))
    (if (null? obj)
         (append s r)
      (append s (make-list (+ 1 (- end start)) (car obj)) r)
    )
))

(define (linsert lis index . obj)
  (append (list-head lis index)
         obj (list-tail lis (- index 1)))
)

(define (lrange lis start end)
  (if (eq? end 'end)
     (list-tail lis (- start 1))
      (list-head (list-tail lis (- start 1)) (- end start -1))
  )
)

   
;;; lsearch -exact lis x
(define (lsearch lis x)
  (do ((i #f)(ind 0))
     ((or i (null? lis)) i)
     (if (equal? x (pop lis))
        (set! i ind)
        (incf ind)
     )
 )
)
(define -exact 
  equal?)

(define (lsearch-test testfn  lis pat)
  (do ((i #f)(ind 0))
     ((or i (null? lis)) i)
     (if (apply testfn (list pat  (pop lis) ))
        (set! i ind)
        (incf ind)
     )
 )
)
#|
(define-macro  (lappend var  arg)
 `(setf  ,var (append ,var (list ,arg))))

(define-macro (incr x)
  `(set! ,x (+ ,x 1)))

(define-macro (lindex lis n)
  `(list-ref ,lis ,n))

(define-macro (!= x y)
  `(not (= ,x ,y))
)
|#
(define-syntax lappend
  (syntax-rules ()
    ((lappend var arg ...)
       (setf var (append var (list arg ...))))
  )
)
#|
(define-syntax incr
  (syntax-rules ()
    ((incr var)
       (setf  var (+ var 1)))
    ((incr var value)
       (setf var (+ var value)))
  )
)
|#
(define-syntax lindex
  (syntax-rules ()
    ((lindex lis n) (list-ref lis n))
  )
)

(define llength length)

(define % modulo)

(define-syntax !=
  (syntax-rules ()
    ((!= x y)  (not (= x y)))
  )
)
;;;;
(define-syntax pop-def
  (syntax-rules ()
    ((pop-def para var default)
        (if (null? para)
             (eval (cadr (assq 'var default)))
             (pop para)
          )
      )
  )
)


(define-syntax define-proc-defaults
   (syntax-rules (default args body)
     ((define-proc-defaults  func  ((var defau)...) expr ...)
        (begin
          (set-prop 'func 'default '((var defau)...))
          (set-prop 'func 'body    '(expr ...))
          (set-prop 'func 'args    '(var  ...))
          (define (func . para)
            (let* ((def (get-prop 'func 'default)))
               (let*  ((var (pop-def para var def)) ...)
                 expr ...))
           )
        )
      )
  )
)

(define-syntax proc-info    ;;;;simulate  tcl info command
   (syntax-rules (args body default)
     ((proc-info args proc)
         (get-prop proc 'args))
     ((proc-info body proc)
         (get-prop proc 'body))
     ((proc-info default proc arg varname)
         (let* ((temp (get-prop proc 'default)))
            (if temp
               (let* ((temp2 (assq arg temp)))
                  (if temp2
                      (begin
                         (set! varname (cadr temp2))
                          #t
                      )
                      #f
                   )
               )
             #f
           )
         )     )
    )
)

;;;   tcl :  info exists var
(define-syntax tcl-info
  (syntax-rules (exists $)
    ((tcl-info exists ($ var ...)) 
       (let* ((temp (assoc  (list var ...)   *tcl-vars*)))
          (if temp
               (not (eq? (cddr temp) *foo*))
               #f
          )
     )
        )
    ((tcl-info exists var)
        (symbol-bind? var))
   )
)

;;;  trace variable
(define (make-sscmd func)  ;;; func must be lambda-object
   (tk-string "{ss " (obj-address func) " -1}")
)

(define (trace-variable var opts func)  ;;; opts w ,r ,u or rw etc.
  (let* ((s 0))
    (set! s (make-sscmd func))
    (set! s (tk-string "trace variable " var " " opts " " s)) 
    (tcl s)
))

(define (trace-vdelete var opts func)  ;;; opts w ,r ,u or rw etc.
  (let* ((s 0))
    (set! s (make-sscmd func))
    (set! s (tk-string "trace vdelete " var " " opts " " s))       
    (tcl s)
))

(define (trace-vinfo var)
  (tcl (tk-string "trace vinfo " var))
)

#| usage
  (define test (lambda (x  y z) (format #t "~s ~s ~s" x y z)))
  (trace-variable 'mode 'w test)
  (trace-vinfo  'mode )

  (trace-vdelete 'mode 'w test)

|#

