/***  big.c
***/
#define  BIG_C

#include "lisp.h"
#include <stdio.h>
/*** #include "GMP/gmp.h"          **All GMP programs need to include gmp.h */

mpz_t mpzwork1,mpzwork2;

// ptr bignum(long); 
ptr mpz2bignum();

void init_big(){
mpz_init(mpzwork1);
mpz_init(mpzwork2);
}

/***  p must >0 and BIGINT  , return unsigned integer   04.4.24 ***/

unsigned long int GET32NUM(ptr p)
{
   return mpz_get_ui(BIGNUM(p));
}

ptr check16(p)
  Reg ptr p;
  /****  p MUST be   BIG  ,  if p is SINT then p--->SINT   ****/
{
  Reg INT n;
   if(SINTP(p)) return p;
   psh(p);
   /***   if(mpz_fits_slong_p(BIGNUM(p))){    64bit!!  ***/
   if(mpz_fits_slong_p(BIGNUM(p))){
      n=mpz_get_si(BIGNUM(p));
    //   printf("check16 p=%p  n=%lx\n",p,n);
      if((n<=SINTMAX)&&(n>=SINTMIN)){
      // printf("check16 p=%p  n=%lx  ->SINT\n",p,n);
         pull();
         return MAKESINT(n);
       }
    }
  pull();
  return p;
}


ptr mpz_check16(mpz_t x)
{
  Reg INT n;
   /*** if(mpz_fits_sint_p(x)){  signed int not 64bit! only 32***/
   if(mpz_fits_slong_p(x)){  //  fits to signed long
      n=mpz_get_si(x);
      // printf("mpz_check16 x=%p  n=%lx =%ld\n",x,n,n);
       //printf("mpz_check16 SINTMIN %lx %ld\n",SINTMIN,SINTMIN);
       //printf("mpz_ch   <=  %d >=  %d\n",n<=SINTMAX,n>=SINTMIN);
      if((n<=SINTMAX)&&(n>=SINTMIN)){
        // printf("mpz_check16 x=%p  n=%lx  ->SINT\n",x,n);
         return MAKESINT(n);
      }
   }
  return mpz2bignum(x);
}


ptr mpz2bignum(mpz_t num)
{
 ptr z;
   z=new_cell(BIGINT);
   psh(z);
 BIGNUM(z)=Mymalloc(sizeof(MP_INT));
 /*** printf("size MP_INT %x\n",sizeof(MP_INT));     0x0c ***/
 mpz_init_set(BIGNUM(z),num);
  pull();
 return z;
}

ptr ptr2bignum(ptr x)
{
 long val;
   if(SINTP(x)) {
     val=GETNUM(x);
                 return  bignum(val);
    }
  else if(BIGINTP(x))
                 return x;
  else
    return  error(E_notint, x);
}

ptr bignum(long n)    
{
  ptr z;
   z=new_cell(BIGINT);
   psh(z);
  BIGNUM(z) = Mymalloc(sizeof(MP_INT)); 
  mpz_init_set_si(BIGNUM(z), n);
  pull();
  return z; 
}

/*** 2005.3.21  for big file size ***/
/***  64bit big positive integer -> bignum  ***/
ptr bignum64(unsigned long high, unsigned long low)
{
  ptr z;
   z=new_cell(BIGINT);
   psh(z);
  BIGNUM(z) = Mymalloc(sizeof(MP_INT));
  mpz_init_set_ui(BIGNUM(z), high);
  mpz_mul_2exp(BIGNUM(z),BIGNUM(z),32);
  mpz_add_ui(BIGNUM(z),BIGNUM(z),low);
  pull();
   z=check16(z);
  return z;
}


/***
bigtest(){
ptr x;
printf("cell size %x\n",sizeof(struct _cell));
printf("double size %x\n",sizeof(double));
}
***/

