/***  gbc.c
***/
#define  GBC_C
#include "lisp.h"
#include  <stdlib.h>
#include  <stdio.h>
#include  <string.h>

/***  -> tklisp.h
#ifdef USE_TK
#include <tk.h>
#endif
***/

#define LEFT 0
#define RIGHT 1
//#define DEBUG(x) x
#define DEBUG(x)

#define SETMARK(p)  (MARK(p)|=GBCMARK)
#define CLRMARK(p)  (MARK(p)&=0xfffffff)
#define ISMARK(p)  (MARK(p)&GBCMARK)
#define B_ISMARK(n)  ((n)&GBCMARK)
#define SETFREE(p)  (MARK(p)|=FREECELL)


#define is_obj(p)  (!SREGP(p))  
extern Uchar *dbp(ptr);
extern ptr PC[],*pc_stack;
extern ptr MPU[],*mpu_stack;
extern char gbcmsg[];       //   for debug
/**  V2.0  ***/
extern ptr SYSREG[];
extern ptr SCM,VMENV,ARGS,VPC,MULTIVAL,ST,BA;
/*** compiler ***/
extern ptr CPC[],*cpc_stack;
extern ptr OUTCOMP[],*comp;/***  scm needs !!! ***/

extern ptr chistory[];
extern int check_cell();
extern int cell_bank;
extern ptr cell_begin[],cell_end[];
extern ptr after_cmd[];
extern ptr *get_alloc();
extern void extends_cell(void);

int gbc_verbos=0;   
static int gbc_count=0;   
static double gbc_time=0.0;   
extern double my_time();
extern int cell_total;


void markit();
void free_num();
void free_tklink(); 
void symbol_setmark();
int virgin(ptr);
int sweep();
int sweep_aux(ptr begin,ptr end);
void free_alloc_cell( ptr );
void free_malloc( ptr ); 
  
// debug

int attr_cl[64]={0};  //debug
static void prin_attr(){
 int i=0,x;
 while(i<64){
   x=attr_cl[i];
   if(x==0) return;
   fprintf(stderr,"gbc attr record %x\n",x);
   i++;
}
}

static int rec_attr(int n){
 int i=0,x;
 while(i<64){
   x=attr_cl[i];
   if(x==0) break; 
   if(x==n)  return 0;
   i++;
}
 if(i==64){
   fprintf(stderr,"gbc attr record OverFlow!\n");
   prin_attr();
   return -1;
 }
  attr_cl[i]=n;
  return n;
}
 
ptr s_gbc_debug(int narg,ptr env){
  ptr x;
  checknarg(narg-1);
   x=*(stack-1);
  if(x!=a_f) gbc_verbos=1;
  else gbc_verbos=0;
  return x;
}
 
ptr gbc()
  {
   Reg ptr q,*pst;
   Reg int i;
   Reg char *cp;
   double gbc_sec;
      //gbc_verbos=1;  //Debug 1  
   gbc_sec=my_time();
   if((gbc_sec>0.0)&&((gbc_sec-gbc_time)<5.0))
      gbc_count++;
   else
      gbc_count=0;
   gbc_time=gbc_sec;
   
    if(gbc_verbos) 
 printf("gbc start .... %s \n",gbcmsg);

  /**** special   ***/ 
    SETMARK(a_nil);
    SETMARK(a_f);
    SETMARK(a_t);
    SETMARK(a_undef);
    SETMARK(a_unbdd);
    /**  printf("gbc a_env %x\n",a_env);  **/
    /** markit(a_env);   * environment ***/
   if(gbc_verbos)  printf("gbc env end\n");
    /*** markit(scm);**/
   /**  markit(multiscm);***/
  /*** sysprotect   nullstr, etc  ***/
  pst=sysprotect;
  i=0;
    if(gbc_verbos) printf("gbc syspro %d start \n",syspro);
  while(i++<syspro){ 
           DEBUG(printf("gbc syspro i=%d  %p\n",i,*pst));
       markit(*pst++);
   }
   if(gbc_verbos)  printf("gbc syspro end\n");
  /*** interned symbol  ***/
  symbol_setmark();
   if(gbc_verbos)  printf("gbc symbol end\n");
   /*** PC stack  m.c **/
  /***   MPU stack  ***/
   i=0;
   pst=mpu_stack;
    while(--pst>=MPU)
     {
       i++;
      q=*pst;
      //if(OBJP(q))
      if(q!=NULL)
      {
        markit(q);
      }
     }
        //  fprintf(stderr,"**********  gbc MPU not OBJP %p\n",q);
         /***  return NO;  ***  to be error!!!  toriaezu!!! ****/

   if(gbc_verbos)  fprintf(stderr,"gbc MPU-stack end %d\n",i);
  /*** CPC stack ***/
 /*** OTCOMP  **
***/
 
  /*** stack  **/
    pst=stack;
    while(--pst>=stack_base)
     {
      q=*pst;
      if(is_obj(q))
      {
         if(gbc_verbos){
         fprintf(stderr,"gbc stack %p attr %x\n",q,ATTR(q));
         }
        markit(q);
      }
    }
   if(gbc_verbos)  fprintf(stderr,"gbc stack end\n");
   /** V2.0  ***/
    pst=SYSREG;
      while((q=*pst++))
     {
        markit(q);
     }
   if(gbc_verbos)  fprintf(stderr,"gbc SYSREG end\n");
    markit(SCM);
    markit(ST);
    markit(BA);
    markit(VMENV);
    markit(ARGS);
    markit(VPC);
    markit(MULTIVAL);

   if(gbc_verbos)  fprintf(stderr,"gbc SCM... end\n");

  /*** frame  
    pst=frame;
    while(--pst>=frame_base)
     {
      if(is_obj(*pst))
      {
        markit(*pst);
      }
     }
   if(gbc_verbos)  printf("gbc frame end\n");
  ***/
   /***  after_cmds  ***/
  pst=after_cmd+AFTERMAX;
    while(--pst>=after_cmd)
     {
        markit(*pst);
     }
   if(gbc_verbos)  fprintf(stderr,"gbc after_cmd  end\n");

   pst=chistory;
   i=0;
    while(i<HISMAX)
     {
      if(is_obj(*pst))
      {
        markit(*pst);
      }
      pst++;
     i++;
     }
   if(gbc_verbos)  fprintf(stderr,"gbc combination history end\n");

  i=sweep();
   if(gbc_verbos)  fprintf(stderr,"gbc sweep end\n");
  if(free_cell==a_nil){
     extends_cell();
     gbc_count=0;
    /** fatal_error(E_cell,a_nil);  **  Cell runs out:fatal  ****/
  } 
   if((gbc_count>=2)&&((i+i)<cell_total)){
              extends_cell();
              gbc_count=0;
      }
     if(gbc_verbos){
        DEBUG(prin_attr());
        fprintf(stderr,"......  gbc  end %s\n",gbcmsg); 
     }
    return a_t;
  }

void symbol_setmark(){
   markit(a_all_packages);
}

/*** debug markit  ***/
static int Not=0;

void markit(p)
  Reg ptr p;
 {
   static int n=0,obj=0;
   int pn=n,pobj=obj,type;
  loop:
    if(!virgin(p)) return; 
    SETMARK(p);
    markit(CAR(p));
    /** markit(CDR(p));  ***/
    /*** tail recursion  ***/
    p=CDR(p);
    goto loop;
}
    
int virgin(p)
  Reg ptr p;
 {
   Reg ptr q,*r;
   int n,m,s;
   int ftype;
 
    if(p==NULL||SREGP(p)) return NO;  
  /***
    if(!OBJP(p)){
         fprintf(stderr,"************  virgin  not OBJP %p\n",p);
         return NO;  //  to be error!!!  toriaezu!!! 
    }
  ***/
    n=(int) MARK(p);
    if(B_ISMARK(n)) return NO; // already mark 
    n&=TYPEMASK;
   /**  printf("  gbc virgin p %x  n %x\n",p,n); **/
    if(B_CONSP(n)) return YES;
    if(B_NUMBERP(n))
      {
        if(B_COMPLEXP(n)){
           return YES;
        }
       else
          SETMARK(p);
        return NO;
      }
     else  if(B_SYMBOLP(n)||B_KEYWORDP(n)) 
      {
          /***  printf("  gbc SYMBOL %x ",p); **/
         return YES;
      }
     else  if(B_STRINGP(n)) 
      {
          SETMARK(p);
          //q=CAR(p);   /****   in space area ***/
          //SETMARK(q);
          return NO;
           /***  CDR(p)=length No mark needs **/
      }
     else  if(B_VECTORP(n))
      {
          SETMARK(p);
          //   n=(long)CDR(p);
          n=GETNUM(CDR(p));  // changed 2019
          q=CAR(p);   /****   in space area ***/
          //SETMARK(q);
          /***  n=CDR(p);   size  in short !**/
          //  org r=(ptr *)(++q);
          r=(ptr *)(q);
          while(n--) markit(*r++);
          return NO;
      }
      else  if(n&MATRIX)
      {
          SETMARK(p);
          SETMARK(CDR(p));
          m=GETNUM(CADR(p));
          s=GETNUM(CDDR(p));
          n=GETNUM(CADR(p))*GETNUM(CDDR(p));
          /***
          if(n>1000||n<0)
            fprintf(stderr,"gbc matrix  n=%d,m=%x,s=%x\n",n,m,s);
          ***/
          q=CAR(p);   /****   in space area ***/
          //SETMARK(q);
          /*** n=CDR(p);   size **/
          r=(ptr *)(q);
          // org r=(ptr *)(++q);
          while(n--) markit(*r++);
          return NO;
           /***  CDR(p)=length No mark needs **/
      }

       else  if(B_CLOSUREP(n))
      {
          DEBUG(rec_attr(n)); //debug

          SETMARK(p);
           q=p;
          //ftype=FTYPE(p);  //  This is ftype
          ftype=EXATTR(p);
          //DEBUG(printf("CLOSURE setmark %p type %x ftype %lx\n",q,n,ftype));
          //  for change FENV,FBODY
           if(n==SLAMBDA||n==SPECIAL){ // system subr
                 // fprintf(stderr,"gbc SLAMBDA enter %p!\n",p);
                    markit(CAR(p));
                   // fprintf(stderr,"gbc SLAMBDA end\n");
             return NO;
          }
          //
         // p=CDR(p);   /****   skip type ***/
          //SETMARK(p);
          if(n==SR2||n==SYNTAXLAMBDA){   // sr2 
             markit(CDR(p));  //SR2
             markit(CAR(p));  /*** env  ***/
             return NO;
         }
          // Never
           fprintf(stderr," SUBRADD???  %p type %x ftype %x\n",q,n,ftype);
                //  error?
             markit(CAR(p));  /*** env  ***/
             return NO;
      }
      else if(n==SYNTAX)   /*** SYNTAXLAMBDA checked by CLOSURE ***/
      {
          return YES;
      }
      else  if(B_STREAMP(n))
      {
          SETMARK(p);
           // CAR(p) is ac_flags->  RLOC v2.20  Not OBJ
          SETMARK(p=CDR(p));  /*** needs mark each cell ***/
           // CAR(p) is  loc  int
          SETMARK(p=CDR(p));
          /*** file,string,lamba  ***/
          markit(CDR(p)); 
          return NO;
      }
    else  if(n&NOCAR){
           // v2.20  this needs for rare case  .   see makestream open.c
          SETMARK(p);
          markit(CDR(p)); 
          return NO;
     }
     else if(n&STRUCTURE) {
         return YES;
    }
     else if(B_EXTP(n)) {
                   /*** Hash, package  ***/
            /***
             if(gbc_verbos){
                  printf("EXT %p  type %x\n",p,n);
             }
            ***/
         return YES;
        }
   /***  else if (n&MULTI)
         return YES;
        V2.0 Not use ***/
#ifdef USE_TK
     else if(n&TKOBJ){
           SETMARK(p);
           SETMARK(CDR(p));
           virgin(CDDR(p));  /*** name-string ***/
          return NO;
      }    
#endif
     else if(n&MALLOC){
           SETMARK(p);
           if(n&MALLOC_BIN) return NO;
           r=get_alloc(p,&n);
           /*** printf("gbc MALLOC alloc %x %d\n",r,n); ***/
           if(r!=(ptr *)-1){
              while(n--){
                 q=*r++;
                 markit(q);
                 /***
                 if(OBJP(q)) markit(q);
                  else{
                    fprintf(stderr,"gbc MALLOC not OBJP %p\n",q);
                      //  return NO;  //  to be error!!!  toriaezu!!! 
                      }
                  ***/
               }
           }
          return NO;
     }
     else if(n&NETSOCKET){
           SETMARK(p);
           if(SINTP(CAR(p))) return NO;
           markit(CAR(p));
           return NO;
      }
     else
        ;
      printf("gbc not in system %lx  attr %x \n",(unsigned long)p,n);
      printf("a_undef %lx   \n",(unsigned long)a_undef);
      fatal_error(E_system,p);
      
      SETMARK(p);
    return NO;
 }

int sweep()
{
  Reg int n=cell_bank;
 sweep_aux(fc_begp,fc_endp);
  while(n--){
     sweep_aux(cell_begin[n],cell_end[n]);
  }
    n=check_cell(free_cell,-1);
 if(gbc_verbos){
       printf(" cell total free %d in %d\n",n,cell_total);
     }
 /**** special  2019.12.31 ***/
    CLRMARK(a_nil);
    CLRMARK(a_f);
    CLRMARK(a_t);
    CLRMARK(a_undef);
    CLRMARK(a_unbdd);
   return n;
}

static int check_complex(ptr p){
   ptr x;
   if((!SINTP(CAR(p))&&ISMARK(CAR(p)))||(!SINTP(CDR(p))&&(ISMARK(CDR(p))))){
       fprintf(stderr,"gbc Found not stacked complex  number!\n");
     return 1;
   }
   return 0;
}

int sweep_aux(ptr begin,ptr end)
 {
  /***  CELL sweep   ***/
  Reg ptr p;
  Reg int s=0,n;
  p=end;
  /***  free_cell=a_nil;     ***/
  do
   {
     n=MARK(--p);
     //2018.3.10  Bug of Math
     //  Need math  debug!
     //if(B_COMPLEXP(n)){
         //if(check_complex(p))
         //  n=GBCMARK;  //Not sweep!
      //}
     if(B_ISMARK(n)) 
      {
           CLRMARK(p);   /***clear gbc mark ***/
      }
     else if(n&FREECELL)
       ;
     else
      {
         if(NUMBERP(p)) free_num(p);
#ifdef USE_TK
         else if(n&TKOBJ) free_tklink(p);
#endif
         else if(n&MALLOC) free_malloc(p);
         else if(B_STRINGP(n)||B_VECTORP(n)||(n&MATRIX)){
                /***
                 if(OBJP(CAR(p))){
                     if(gbc_verbos){ // ***  error? ***
                         printf("gbc  %lx addr %lx  attr %x\n",(UL)p,(UL)CAR(p),n);
                         prin1(CAR(p),STDOUT);
                     }
                   }
                 else
                ***/
                    Myfree(CAR(p));
          }
         else if(n&NETSOCKET){
              if(SINTP(CAR(p)))
                      Myfree(CDR(p));
              /***  the following  no good, may be reopen
                 else
                   close((int)CDR(p));
                ***/
          }
         s++;
         CAR(p)=a_f;  //this means (#f ...)
         //CAR(p)=a_t;
         CDR(p)=free_cell;
         MARK(p)=FREECELL;    /**  FREECELL;  ** ***/
         free_cell=p;
      }
    }  while(p!=begin);
  if(gbc_verbos){
       printf(" cell begin %lx end %lx \n",(UL)begin,(UL)end);
       printf(" cell  free added %d \n",s);
     }
  return s;
}
void Free_cell(ptr p){   // only cell
      MARK(p)=FREECELL;  /*** CONS ***/
          CAR(p)=a_nil;
          CDR(p)=free_cell;
          free_cell=p;
}

void free_num(Reg ptr p){  /****  GMP clear  needs   ****/
Reg int n=ATTR(p);

if(B_BIGINTP(n)){
  /*** 04.1.3  **/
  /*** if(BIGNUM(p)==a_nil) printf("myfree error bignum\n");  ***/
  mpz_clear(BIGNUM(p));
  Myfree(BIGNUM(p));
 
}
else if(B_RATIOP(n)){
  /*** 04.1.3  **/
  /*** if(RATIONAL(p)==a_nil) printf("myfree error rational\n");  ***/
  mpq_clear(RATIONAL(p));
  Myfree(RATIONAL(p));
}
else if(B_COMPLEXP(n)){
   //  2018.3.10  needs????
  
}
else
  ;
 return;
}

#ifdef USE_TK

void free_tklink(Reg ptr p){ 
 char *q;
 Uint n;
 extern Tcl_Interp *myInterp;

if((long)CAR(p)==STRING) return;
if(CAR(p)){
     q=(char *)get_string(CDR(p),&n);
     Tcl_UnlinkVar(myInterp,q);
     Tcl_Free((char *)CAR(p)); /*** this is cdr cell of TKOBJ  ***/
 }
}
#endif

void free_alloc_cell(Reg ptr p){
  free_malloc(p);
   CAR(p)=a_nil;
   CDR(p)=free_cell;
   MARK(p)=FREECELL;    /**  FREECELL;  ** ***/
   free_cell=p;
}


void free_malloc(Reg ptr p){ 
  /*** if(CAR(p)==a_nil) printf("myfree error malloc %x %x %x\n",p,CAR(p),CDR(p)); ***/
   if(CAR(p)!=(ptr)-1){
      Myfree((void *)CAR(p));
      CAR(p)=(ptr)-1;
   }
}


ptr s_gbc(int narg,ptr env){
  ptr s;
  Uchar *q;
  int n=0,org=gbc_verbos;
 if(narg==1){
       s=*(stack-1);
       gbc_verbos=(s!=a_f);
      if(STRINGP(s)){
          q=get_string(s,(Uint *)&n); 
          memcpy(gbcmsg,q,n);
      }
    *(gbcmsg+n)='\0';
 }else{
       gbc_verbos=1;
  strcpy(gbcmsg,"by USER");
   }
  gbc();
 gbc_verbos=org;
 return a_undef;
}
         

        
         
    

