/***  struct.c
   2004.7.7 
 ***/
/***  struct   support  ***/
/***  (name . vector)   ***/
/***   2005.1.22  change   ***/
/****  (name vector . include-offset)   ****/
/***  include-offset is a assoc list of included structure, whic includes all(!)
    children!!!
    this is computed in macro definition!
***/

#include "lisp.h"
/***  E_notstruct    E_struct_access  ***/

/*** (make-struct  name arg1 ....   )   ****/
/*** (make-struct  name (offset-list) arg1 ....   )  to be in sys:   ****/
extern ptr *get_vector();

static int structure_size(ptr name)
{
   ptr x;
   x=assq(name,ATOMVAL(a_structure_size));
   if(x==a_f){
         error(E_notstruct,name);
    }
   return  GETNUM(CDR(x));
}

static int struct_size(ptr s){
  int n;
  if(SREGP(s)||!STRUCTP(s)) error(E_notstruct,s); /***  structure name***/
  s=CADR(s);
  get_vector(s,&n);
  return n;
}

ptr s_struct_size(int narg,ptr env)
{
  int n;
   checknarg(narg-1);
   n=struct_size(*(stack-1));
   return MAKESINT(n);
}
/***  OLD (make-struct  name arg1 ....   )   ****/
/***  NEW  (make-struct  name (include list) arg1 ....   )  to be in sys:   ****/
ptr s_make_struct(int narg,ptr env)
{
  ptr name,s,v,*args,*slot,offset;
  int n;
  if(narg<=2) checknarg(-1);
  args=stack-narg;
  name=*args++;
  if(SREGP(name)||!SYMBOLP(name)) error(E_notsymb,name); /***  structure name***/
  s=new_cell(STRUCTURE);
  psh(s);
  offset=*args++;
  narg--;
  v=CONS(a_nil,offset);  /*** offset given in ss level  ***/
  CDR(s)=v;
 
  CAR(s)=name;
  //v=CAR(v)=getvector(--narg);
  v=CAR(v)=makevector(--narg,ZERO);
  slot=get_vector(v,&n);
  while(narg--){
   *slot++=*args++;
  }
  pull();
  return s;
}

/*****   included in s_subcopy_struct
ptr s_copy_struct(int narg,ptr env)
{
  ptr name,s,v,str;
  int n;
   checknarg(narg-1);
   s=*(stack-1);
  if(SREGP(s)||!STRUCTP(s)) error(E_notstruct,s);
  psh(v=new_cell(STRUCTURE));
  str=v;
  CAR(v)=CAR(s);
  s=CDR(s);
  v=CDR(v)=CONS(a_nil,a_nil);
  CDR(v)=CDR(s);
  CAR(v)=vector_copy(CAR(s));
  pull();
  return str;
}
****/

ptr s_struct_vector(int narg,ptr env)
{
  ptr s;
  int n;
   checknarg(narg-1);
  s=*(stack-1);
  if(SREGP(s)||!STRUCTP(s)) error(E_notstruct,s);
  return CADR(s);
}

ptr structure_offset(ptr name)
{
  ptr v;
  v=assq(name,ATOMVAL(a_structure_offset));
     if(v!=a_f) return CDR(v);
  return error(E_notstruct,name);
}

ptr s_struct_offset(int narg,ptr env)
{
  ptr s,v;
  int n;
   checknarg(narg-1);
  s=*(stack-1);
  if(SREGP(s)) error(E_notstruct,s);
  if(STRUCTP(s))
           return CDDR(s);
   return structure_offset(s);
}

ptr s_struct_name(int narg,ptr env)
{
  ptr s;
  int n;
   checknarg(narg-1);
  s=*(stack-1);
  if(SREGP(s)||!STRUCTP(s)) error(E_notstruct,s);
  return CAR(s);
}

ptr s_struct_p(int narg,ptr env)
{
  ptr s;
  int n;
   checknarg(narg-1);
  s=*(stack-1);
  if(SREGP(s)||!STRUCTP(s)) return a_f;
  return CAR(s);
}

/****  (struct-ref obj  name slot-num)    name indicates access-struct   which may be not
  equal the type of object   ***/

static ptr offset_ref(ptr name,int slot,ptr offset,ptr *vec)
{
  ptr f;
  int n;
  f=assq(name,offset);
  if(f==a_f) error(E_struct_access,name);
  n=GETNUM(CDR(f));
  return *(vec+n+slot);
}

ptr s_struct_ref(int narg,ptr env)
{
  ptr s,name,slot,v,*vec;
  int n;
   checknarg(narg-3);
  s=*(stack-3);
  name=*(stack-2);
  slot=*(stack-1);
  if(SREGP(s)||!STRUCTP(s)) error(E_notstruct,s);
  v=CADR(s);
  vec=get_vector(v,&n);
  n=GETNUM(slot);
  if(CAR(s)!=name) return offset_ref(name,n,CDDR(s),vec);
  return *(vec+n);
}

/****  (struct-set obj  name slot-num value)   ***/
static ptr offset_set(ptr name,ptr offset,ptr *vec,ptr *frame,int narg)
{
  ptr f,val,slot;
  int shift,n;
  f=assq(name,offset);
  if(f==a_f) error(E_struct_access,name);
  shift=GETNUM(CDR(f));
  while(narg>0){
    slot=*frame++;
     val=*frame++;
     n=GETNUM(slot);
    *(vec+n+shift)=val;
    narg-=2;
  }
  return a_undef;
}

ptr s_struct_set(int narg,ptr env)
{
  ptr s,name,slot,v,*vec,val,*frame;
  int n;
   if(narg<4) checknarg(narg-4);
  frame=stack-narg;
  name=*frame;
  s=*(frame+1);
  frame+=2;
  if(SREGP(s)||!STRUCTP(s)) error(E_notstruct,s);
  v=CADR(s);
  vec=get_vector(v,&n);
  narg-=2;
  if(CAR(s)!=name) return offset_set(name,CDDR(s),vec,frame,narg);
  while(narg>0){
     slot=*frame++;
     val=*frame++;
     n=GETNUM(slot);
     *(vec+n)=val;
      narg-=2;
  }
  return a_undef;
}

static int get_shift_offset(ptr name,ptr off, int sh)
{
  ptr n;
  while(off!=a_nil){
    if(CAR(CAR(off))==name){
        if(sh==0) break;
        sh--;
    }
   off=CDR(off);
 }
 if(off==a_nil) error(E_struct_access,name);
 n=CDR(CAR(off));
 return GETNUM(n);
}

static ptr make_by_name(ptr name)
{
 ptr off,v,str;
 int n;
   n=structure_size(name);
  /** printf("by_namey shift %d %x\n",n,name); ***/
   off=structure_offset(name);  
  psh(str=v=new_cell(STRUCTURE));
  CAR(v)=name;
  v=CDR(v)=CONS(a_nil,off);
  //CAR(v)=getvector(n);
  CAR(v)=makevector(n,ZERO);
  pull();
  return str;
}
   
static ptr subcopy(ptr obj,ptr name,int sh)
{
 ptr x,v,*vec,str,off,new,*dest;
 int n,size;
  obj=CDR(obj);
  off=CDR(obj);
  vec=get_vector(CAR(obj),&n);
  n=get_shift_offset(name,off,sh);
  /*** printf("subcopy shift %d %x\n",n,vec); ***/
  vec+=n;
  new=make_by_name(name);
  dest=get_vector(CADR(new),&size);
  while(size--)
     *dest++=*vec++;
  return new;
}  
/****  (substructure-copy obj name [shift])   ****/
ptr s_subcopy_struct(int narg,ptr env)
{
  ptr name,s,v,str,*frame;
  int n,sh;
   /** if(narg==1) return s_copy_struct(narg,env); ***/
   frame=stack-narg;
   sh=0;
   if(narg==3)
     sh=GETNUM(*(stack-1));
   else if((narg==0)||(narg>3))
     checknarg(narg-3);
   s=*frame++;
   if(narg==1) 
        name=CAR(s);
    else
        name=*frame;
  if(SREGP(s)||!STRUCTP(s)) error(E_notstruct,s);
  if(SREGP(name)||!SYMBOLP(name)) error(E_notsymb,s);
  if(name!=CAR(s)) return subcopy(s,name,sh);
  if(sh) error(E_struct_access,s);
  psh(v=new_cell(STRUCTURE));
  str=v;
  CAR(v)=CAR(s);
  s=CDR(s);
  v=CDR(v)=CONS(a_nil,a_nil);
  CDR(v)=CDR(s);
  CAR(v)=vector_copy(CAR(s));
  pull();
  return str;
}

static ptr sub_subst(ptr obj,ptr dest,ptr name,int sh)
{
 ptr *vec,str,off,*orig;
 int n,size;
  str=dest;
  str=CDR(str);
  off=CDR(str);
  vec=get_vector(CAR(str),&n);
  n=get_shift_offset(name,off,sh);
  /*** printf("subcopy shift %d %x\n",n,vec); ***/
  vec+=n;
  orig=get_vector(CADR(obj),&size);
  while(size--)
    *vec++=*orig++;
  return dest;
}

/****  (subst_structure obj dest shift)   ****/
ptr s_subst_struct(int narg,ptr env)
{
  ptr name,s,dest,v,*frame,*store;
  int n,sh;
   frame=stack-narg;
   if(narg==2)  sh=0;
   else if(narg==3)
     sh=GETNUM(*(stack-1));
   else
     checknarg(narg-3);
   s=*frame++;
   dest=*frame;
  if(SREGP(s)||!STRUCTP(s)) error(E_notstruct,s);
  if(SREGP(dest)||!STRUCTP(dest)) error(E_notstruct,dest);
  name=CAR(s);
  if(name!=CAR(dest)) return sub_subst(s,dest,name,sh);
  if(sh) error(E_struct_access,s);
  s=CADR(s);
  v=CADR(dest);
  frame=get_vector(s,&n);
  store=get_vector(v,&n);
  while(n--)
    *store++=*frame++;
  return dest;
}

