;;; usage:  (select-dialog item-list [select-proc [topw]])
;;;  if no-item then #f
;;;  if no selection,   #f  is returned
;;;;  else return
;;;     ( select-proc  item)
;;;      coomand when OK invoked.
;;;      2004.9.1 
;;;    revised 2005.3.28
;;;
(in-package "dialog")

(define (select-dialog  items . sel-proc)
    (if (null? items) 
         #f     ;;;;;  caution!!!
      (let* ((proc #f) (top #f) (hi 400) )
         (when (pair? sel-proc)
             (set! proc (pop sel-proc))
             (if (pair? sel-proc)
                   (set! top (car sel-proc))
             )
          )
          (when (not top)
               (set! top (gen-toplevel '.sel))
               (wm 'title  top  "Select window")
               ;(wm 'geometry top "250x430+80+80")
               (wm 'geometry top (tk-string "250x" hi "+80+80")) 
           )
         (select-main items proc top)
      )
   )
)

(define (select-main items  proc top)
  (let* ((answer #f) (n 0) (h 0) (proc-org proc)
       (lbox 0)(lbox_ysc 0)(lbox_xsc 0)(lab1 0)(but-ok 0)(but-can 0))
     (set! n  (length items) )
     (if (> n 16) (set! n 16))
     (set! h (* (+ n 5) 20))
    (set! lbox (tk-name top ".wdir"))
    (set! lbox_ysc (tk-name lbox "y_scroll"))
     (listbox  lbox  
        :yscrollcommand
                  (lambda l (apply  (function lbox_ysc) 'set l))
       :width 25  :height n)

     (scrollbar  lbox_ysc  :orient 'vertical
                 :command
                    (lambda l (apply  (function lbox)  'yview l))
       )
     (grid  lbox lbox_ysc
           :row 0  :sticky 'news)

     (set! lbox_xsc (tk-name lbox "x_scroll"))
     (funcall   lbox 'configure 
        :xscrollcommand
                  (lambda l (apply  (function lbox_xsc) 'set l))
       :width 25 :height n)
     (scrollbar  lbox_xsc  :orient 'horizontal
                 :command
                    (lambda l (apply  (function lbox)  'xview l))
       )
     (grid   lbox_xsc
           :row 1  :sticky 'nwe)

     (set! lab1 (tk-name top ".name"))
     (label lab1  :text "select" :bg 'snow :width 25  :height 1)
     (grid  lab1  :row 2 :column 0 :sticky 'ew)
     (set! but-ok (tk-name top ".ok"))
     (if (not proc)
             (set! proc (lambda(x) (destroy top)))
     )
     (button but-ok :text "OK" :command (lambda ()(proc answer)))
     (set! but-can (tk-name top ".can"))
     (button but-can :text "CANCEL" :command 
                        (lambda()  (set! answer #f)(destroy top))  )
     (grid but-ok  :row 3 :column 0 :sticky 'ew ) 
     (grid  but-can :row 4 :column 0 :sticky 'e )   ;;;  :sticky 'ew )

    (set-items  items lbox)     
    (bind lbox   "<Button-1>" 
        (lambda (y)
             (set! answer (get-item-ypos  y items lbox))
             (funcall lab1  'configure :text answer)
                          )
          )
    (bind  top  "<Return>" (lambda () (destroy top)))
     (grid 'rowconfigure top 0 :weight 1)
      (grid 'columnconfigure top 0 :weight 1)

     (if (not proc-org)
        (begin  (tkwait 'window top ) answer)
        top     ;;;  return top for destroy or tkwait in upper level
    )
))

(define (set-items items lbox)
   (let* ((i  0))
   (funcall lbox  'delete 0 'end)
      (do ((x ()) )
          ((null? items) )
         (set! x (pop items))
          (funcall lbox  'insert 'end  x)
          ;;; (format #t "~a~%" x)
          (set! i (+ i 1))
       )
   i
))

(define (get-item-ypos  y items lbox )
         (list-ref items  (funcall lbox  'nearest y  ) )
) 

(export 'select-dialog)
(use-package "dialog" "ss")

;;;(select-dialog '("test" "ok" "whoo" "ss" "hhh" "p" "q" "r" "i" "ooo" "yyy" ))



