;;;;  regexp-nfa  a simple call version
;;;;   loop& stack version Ver3.0
;;;;    2005.9.17  created
;;;;     stack kstack  version     from 3.2

(in-package "regexp")

(define-syntax push-state
   (syntax-rules ()
      ((push-state state stack)
              (begin
                (push (get-group state) stack)
                (push (Rindex state) stack)
             )
       )
   )
)

(define-syntax pull-state
   (syntax-rules ()
      ((pull-state state stack)
             (begin
               (set-Rindex state (pop stack))
               (set-group  state (pop stack))
               state
             )
       )
   )
)

(define-syntax push-Rindex
   (syntax-rules ()
      ((push-Rindex state stack)
                (push (Rindex state) stack)
       )
   )
)
                                                                                              
(define-syntax pull-Rindex
   (syntax-rules ()
      ((pull-Rindex state stack)
             (begin
               (set-Rindex state (pop stack))
               state
             )
       )
   )
)


(define  (regexp-nfa  state )
 (let* ((trans  (Rstate state))(stack (list trans))(kstack '(()))
           (A 0) (op 0)(orgstate state) )
  (while (and state (pair? stack))
     (set! trans (pop stack))
     ;;;(format #t "nfa  trans ~s stack ~s ~%" trans  stack)
    (when (not (eq? trans 0))
         (set! trans  (get-trans trans))
       (when (not (eq? trans 0))
               (set! A (car trans))
             ;;; (format #t "main trans ~s   car  ~s ~%" trans A)
         (cond ( (symbol? A)
                   (set! state (regexp-nfa-atom trans state)))
               ( (number? A)
                   (push (cdr trans) stack)
                   (push A stack)
               )
       ;;; ((:or C D))  A=(:or C D)   etc.
           (else 
              (set! op (car A))
              (cond ((eq? op :or)
                       (push (caddr A) stack) 
                       (push-state state stack)
                       (push :or stack)
                       (push stack kstack)
                       (push  (cadr A) stack)
           ;;;   (format #t "or state  ~s   stack  ~s ~%" state stack)
                       )
                    ((eq? op :forward)
                       (push-Rindex state stack)
                       (push op stack)
                       (push stack kstack)
                       (push  (cadr A) stack)
                     )
                    (  (eq? op :not)
                       (push-state state stack)
                       (push op stack)
                       (push stack kstack)
                       (push  (cadr A) stack)
                     )
                    ((eq? op :if)
                        (set! kstack (nfa-if (cdr A) state stack kstack))
                        (set! stack (pop kstack))
                      )
                (else
                     (error 543 A)
                )
              )
           )
         )
      )
     )
     (if state
          (when (and  (pair? stack) (eq? stack (car kstack)))
             (set! kstack (key-true-stack state stack kstack))
             (set! state (pop kstack))
             (set! stack (pop kstack))
          )
          (begin
             (set! kstack (key-false-stack orgstate stack kstack))
             (set! state (pop kstack))
             (set! stack (pop kstack))
          )
     )
  )
 state
))

(define  (key-true-stack state stack kstack)
  (let* ((orgstate state)(op 0))
   ;;;; (while (and state  (pair? stack)(eq? stack (car kstack)))  ;;; this need!
            (set! op (pop stack))
            (set! kstack (cdr kstack))
            (cond ((eq? op :or)
              ;;;; (format #t ":or 1st success  stack  ~s ~%" stack)
                        (set! stack (cdddr stack)) ;;;  2nd state, gr,ind  throw
                 )
                 ((eq? op :not)
                        (set! stack (cddr stack)) ;;;   gr,ind  throw
                        (set! state #f)
                   )
                  ((eq? op :forward)
                      (pull-Rindex state stack)
                    )
                 ((eq? op :if)
                     (set! stack (cddr stack)) ;;;   gr,ind  throw
                     (set! op (pop stack))     ;;;; then
                     (set! stack (cons op (cdr stack)))   ;;; else throw, push then
                   )
             (else (error 412 op) )
            )
    ;;;)
   (if  state
            (if (and (pair? stack)(eq? stack (car kstack)))
                   (key-true-stack state stack kstack)
                   (cons  state (cons stack kstack))
            )
           (key-false-stack orgstate stack kstack)
   )
))

(define  (key-false-stack orgstate stack kstack)
  (let* ((state #f)(op 0))
        (set! stack (pop kstack))
        (when (pair? stack)
            (set! op (pop stack))
            (cond ((eq? op :or)
             ;;; (format #t ":or  try to second   stack  ~s ~%" stack)
                          (set! state (pull-state orgstate stack))
                    )
                  ((eq? op :not)
                      (set! state (pull-state orgstate stack))
                    )
                  ((eq? op :forward)
                      (pull-Rindex orgstate stack)  ;;;; still false
                    )
                  ((eq? op :if)
                      (set! state (pull-state orgstate stack))
                      (pop stack)  ;;; throw then
                    )

              (else (error 413 op))
          )
        )
        (if state
            (if (and (pair? stack)(eq? stack (car kstack))) 
                   (key-true-stack state stack kstack)
                   (cons  state (cons stack kstack))
            )
            (if (pair? kstack)
                (key-false-stack orgstate stack kstack)
                (cons  state (cons stack kstack))
            )
        )
))

(define (nfa-if A state stack kstack)
   (let* ( (op (pop A) )(then (pop A))(else 0))
        ;;;;(if (pair? A)
              (set! else (car A))
        ;;;)
         (if (pair? op)
               (if (keyword? (car op))  ;;  (:test n)
                   (begin   ;;;; need copy-state ?
                               ;;;  yes because groups are in stack
                              ;;; However we need pos, group data only for the backup
                       (push else stack)
                       (push then stack)
                       (push-state state stack)
                       (push :if stack)
                        (push stack kstack)
                       (push (cadr op) stack)  ;;; :not , :forward,etc
                                                ;;; Need:test
                    )
                    (if (R-call op state)
                          (push then stack )
                          (push else stack )
                    )
                 )
              (if (str-group-ref op state)
                    (push then stack )
                    (push else stack )
              )
        )
    (cons stack kstack)
))

