;;;dir-copy.ss
;;;   ssftp   copy dir
;;;

;;;  remote dir -> local
(require  "ftp-base")
(in-package "get-file")
(load "confirm")

(define (copy_dir_remote dir local remote . nocheck)
   (and (not (equal? dir ".")) (not (equal? dir ".."))
        (if (member dir (FILES_WIN-files local))
               (begin
                 (format #t "ERROR: Same name regular file exists! Can't copy!~%")
                  #f
                )
             #t
        )
       (if (and (null? nocheck) (member dir (FILES_WIN-dirs local)))
          (confirm-dialog (FILES_WIN-top local) (tk-string "Overwrite " dir))
          #t
       )
      (copy_dir_remote_aux  dir local remote)
   )
)

(define (copy_dir_remote_aux  dir local remote)
   (let* ( (cwd (FILES_WIN-cwd remote))
           (ext (FILES_WIN-ext remote))
           (lcwd (FILES_WIN-cwd local))
           (files 0)
           (dirs 0)
           (ldirs 0)
           (x 0)
         )
     (set-FILES_WIN remote :ext '("*" ".*"))
     (chdir-reset dir remote)
     (set! files (FILES_WIN-files remote))
     (set! dirs (FILES_WIN-dirs  remote))
     (set! ldirs (FILES_WIN-dirs  local))
     ;;;(set! dirs (cddr dirs))   ;;; skip . ..
     (mkdir dir)
     (set-FILES_WIN local :dirs (cons dir ldirs)) ;;; used in chdir-reset
     (local-chd dir)
    (while (pair? files )
       (set! x  (pop files))
       (send-msg (tk-string "get " *-P* x))
       (read-p)
    )
    (while (pair? dirs )
       (set! x  (pop dirs))
       (copy_dir_remote x local remote 'nocheck)
    )
   (local-chd "..")
   (remote-chd "..")
  (set-FILES_WIN remote :ext ext)
   ;;;(format #t "~s~%" res)
   (dir-reset local)
   (dir-reset remote)
))

;;;  local dir -> remote
(define (copy_dir_local dir local remote . nocheck)
 (and (not (equal? dir ".")) (not (equal? dir ".."))
        (if (member dir (FILES_WIN-files remote))
               (begin
                 (format #t "ERROR: Same name regular file exists! Can't copy!~%")
                  #f
                )
             #t
        )
       (if (and (null? nocheck) (member dir (FILES_WIN-dirs remote)))
           (confirm-dialog (FILES_WIN-top remote) (tk-string "Overwrite " dir))
          #t
       )
       (copy_dir_local_aux  dir local remote)
   )
)

(define (copy_dir_local_aux  dir local remote)
   (let* ( 
           (ext (FILES_WIN-ext local))
           (files 0)
           (dirs 0)
           (rdirs 0)
           (x 0)
         )
     (set-FILES_WIN local :ext '("*" ".*"))
     (chdir-reset dir local)
     (set! files (FILES_WIN-files local))
     (set! dirs (FILES_WIN-dirs  local))
     (set! rdirs (FILES_WIN-dirs  remote))
     ;;;(format #t "local files ~si dir ~s~%" files dir)
     ;;(set! dirs (cddr dirs))   ;;; skip . ..
     (when (not (member dir rdirs))
        (send-msg (tk-string "mkdir "  dir))  ;;;remote-mkdir
        (read-p)
        (set-FILES_WIN remote :dirs (cons dir rdirs)) ;;; used in chdir-reset
     )
     (chdir-reset dir remote)
     ;;;(format #t "remote cwd ~s~%" (FILES_WIN-cwd remote))
    (while (pair? files )
       (set! x  (pop files))
       (send-msg (tk-string "put " *-P* x))
       (read-p)
    )
    (while (pair? dirs )
       (set! x  (pop dirs))
       (copy_dir_local  x local remote 'nocheck)
    )
   (local-chd "..")
   (remote-chd "..")
  (set-FILES_WIN local :ext ext)
   ;;;(format #t "~s~%" res)
   (dir-reset local)
   (dir-reset remote)
))

