;;;rmdir.ss
;;;   ssftp   rmdir
;;;    recursively

;;;  remote dir -> local
(require  "ftp-base")
(in-package "get-file")

(define (rmdir-remote-rec  dir remote)
   (and (not (equal? dir ".")) (not (equal? dir ".."))
       (rmdir_remote_aux  dir remote)
   )
)

(define (rmdir_remote_aux  dir  remote)
   (let* ( (cwd (FILES_WIN-cwd remote))
           (ext (FILES_WIN-ext remote))
           (files 0)
           (dirs 0)
           (x 0)
         )
     (set-FILES_WIN remote :ext '("*" ".*"))
     (chdir-reset dir remote)
     (set! files (FILES_WIN-files remote))
     (set! dirs (FILES_WIN-dirs  remote))
    (while (pair? files )
       (set! x  (pop files))
       (remote-remove-file  x)
    )
    (while (pair? dirs )
       (set! x  (pop dirs))
       (rmdir-remote-rec  x  remote)
    )
   (remote-chd "..")
   (rmdir-remote  dir )
   (set-FILES_WIN remote :ext ext)
   ;;;(format #t "~s~%" res)
   (dir-reset remote)
))

;;;  local rmdir
(define (rmdir-local-rec  dir local )
   (and (not (equal? dir ".")) (not (equal? dir ".."))
       (rmdir_local_aux  dir local)
   )
)

(define (rmdir_local_aux  dir local )
   (let* ( 
           (ext (FILES_WIN-ext local))
           (files 0)
           (dirs 0)
           (x 0)
         )
     (set-FILES_WIN local :ext '("*" ".*"))
     (chdir-reset dir local)
     (set! files (FILES_WIN-files local))
     (set! dirs (FILES_WIN-dirs  local))
     ;;;(format #t "local files ~s dir ~s~%" files dir)
     ;;(set! dirs (cddr dirs))   ;;; skip . ..
    (while (pair? files )
       (set! x  (pop files))
       (remove-file  x)
    )
    (while (pair? dirs )
       (set! x  (pop dirs))
       (rmdir-local-rec  x local)
    )
   (local-chd "..")
   (rmdir dir)
   ;;;(format #t "~s~%" res)
   (dir-reset local)
))

