;;; 2004.3.25
;;;  match
#|   create match data base
  p   & f
  1.  p is not pair  
         equal? p f   =>  ()
  2.  p is pair
    (1) p=(pat var)  =>  (var . f)
    (2) P=(macro key) 
           eq? key f  => ()
    (3) p=(literal word ass)
          (eq? word f)   and
          (a) if ass=#f  and f is not local => ()
          (b) if (eq? ass (assq f local-env)) => () 
    (4) p=((... A) . B)
         (a)  if f=()
               if data= (match B ())
                  (cons ((... A)) data)
         (b)  f=(c1 c2  .....  ck  . d)
              &  d1=(match  A c1) ... dk= (match A ck) are true
              &  d=(match B d) is true
              =>  (cons ((... A) d1 d2 .... dk) d)
    (5) p=(A . B)
         f is pair & f=(C . D)
         (cons (match A C) (match B D))

    (6) p=(vector P1 ..... Pn-1 Pn)
        f is vector  size of f >=n-1
        d1=(match P1 f1) ...  dn-1 are true
        (a)  if size of f=n
               dn is true=> (list d1 ... dn)
        (b)  if size of f>n
               dn =(match Pn (fn ....))  true=>(list d1 ... dn)
 |#

(in-package "macro")              
                   
(define (match p f env)
  (if (pair? p )
        (match-pair p f env)
       (if (equal? p f)
              ()
              #f
        )
   )
)

;;;  list? is no good here,  because  (list? '(a . b)) ==> #f
(define (pair-null? x)
  (or (pair? x)(null? x))
)

(define (match-pair p f env)
  (let* ((top (car p)) (rest (cdr p)))
     ;;;(format #t "match-pair ~s ~s ~%" p f)
     (cond ((eq? top 'pat )
               (cons (car rest)  f) )
           ((eq?  top 'macro)
               (if  (eq? f (car rest)) () #f)  )
           ((eq?  top 'literal)
              (if (eq? (car rest) f)
                  (if  (eq? (assq  f env) (cadr rest)) () #f) #f )   )     
           ((vector? f)
              (match-vector p f env))
           ;;;((not (list? f)) #f)
           ((not (pair-null? f)) #f)
           (else
              (match-pair-main p f env)
           )
      )
))

(define (match-pair-main p f env)
   (let* ((top (car p)) (rest (cdr p))(c ()) (d ()) (ans #t)(ans2 #t)(dot-p #f)(res ()))
      (if (pair? f)
          (begin
            (set! c (car f))
            (set! d (cdr f))
          )
      )
    (cond ((and (pair? top)  (eq? (car top) '...))
             (if (null? f)
                 (if (null? rest )
                     (list (list top))   ;;;  0 terms for  ... P
                     (begin
                       (set! d (match rest f env))
                       (if d 
                           (cons  (list top) d)
                           ;;(list (list top) d)
                           #f
                       )
                     )
                 )
                (begin
                  (set! dot-p (cadr top))
                  (while ans2
                     (set! ans (match dot-p c env))
                     (if ans
                        (begin
                          (push ans res)
                          (if (pair? d)
                               (begin
                                 (set! c (car d))
                                 (set! d (cdr d))
                               )
                              (set! ans2 #f)
                           )
                        )
                       (set! ans2 #f)
                    )
                  )
                  (if ans 
                    (begin   ;;;  no terms left  in f
                       (set! d (match rest () env))
                       (if d 
                          (cons (cons top (reverse res))  d )
                          #f
                       )
                     )
                     (begin
                       (set! ans2 (match rest (cons c d) env))
                       (if ans2
                          (cons (cons top (reverse res)) ans2)
                          #f
                       )
                     )
                   ) ;;; if-end     
                  )
               )   )
           #|   Never occur?
            ((eq? top '...)
           |#
             ((eq? top 'vector)
                          #f
                           )
             (else
               (if (null? f)
                   #f
                 (begin
                   (set! ans (match top c env))
                   (if ans             
                     (begin
                       (set! ans2 (match rest d env))
                       (if  ans2
                            (cons  ans ans2)
                            #f
                        )
                      )
                     #f
                   )    
                 )
               )   )

      )
))                      
                               
(define (match-vector p f env)
   (if (eq? (car p) 'vector)
        (match-vector-sub p f env)
        #f
   )
)

(define (match-vector-sub p f env)
   (let* ((res ()) (k 0)(n (vector-length f)) (v (cdr p)) (ans #f)(i 0))
       (set! ans (car v))
       (set! v (cdr v))
       (set! k (length v))
       (set! f (vector->list f))
       (match v f env)
))
                 
#| test
  (match p  '(who ((i 0 (+ i 1)) (j 5)) ( (= i 0)(write a )) h (yo s)) ())

|#
