;;;;  transorm template
;;; 04.4.04
;;; 04.4.17  alias is corrected by
;;;    introducing *template-name-change*
(in-package "macro")

(define  *template-name-change* ())
(define *stop-expand* "stop-expand")
(define *null-dot* "null-dot-env")

(define *temp-dotenv* ())
(define *temp-subenv* ())

(define (get-temp-dotenv temp)
   (set! *temp-dotenv* ())
   (get-temp-dotenv-main temp 0)
)

(define (get-temp-dotenv-main temp level)
  (let* ((top 0))
   (if (pair? temp)
     (begin
       (set! top (car temp))
       (cond  ((eq? top '...)
                 (get-temp-dotenv-main (cadr temp) (+ level 1))   )
              ((eq? top 'pat)
                 (if (> level 0)
                     (set! *temp-dotenv* (cons (get-dot-data (cadr temp) level) 
                                           *temp-dotenv*))
                     ;;;(set! *temp-dotenv* 
                     ;;;    (cons (list (cadr temp) (get-dot-data (cadr temp) level)) 
                     ;;;                      *temp-dotenv*))
                 ) 
                )
             ((or (eq? top 'special) (eq? top 'syntax-macro)(eq? top 'local)
                  (eq? top 'template))
                   ;;; do nothing!
                 )
             (else
                (get-temp-dotenv-main top level)
                (get-temp-dotenv-main (cdr temp) level)
             )
         )
      )
   )
))

;;;  take 1st env & return  (1-stenv . rest-env )
(define (take-1st pat env)
  (let* ((1st ()) (rest ()) (top 0) (s 0))
      (set! env (take-include-pat pat env))
    (while (pair? env)
      (set! top (car env))
      (if (pair? top)
          (begin
            (set! s (car top))
            ;;;;  skip first symbol of (a (a . 5) (a . y) (a . z))
            (if  (symbol? s)
                (begin
                   (set! top (cdr top))
                   (if (pair? top)
                       (set! s (car top))
                       (set! s ())
                   )
                )
             )
            (if (pair-null? s)  ;;;; may be ()   
              (begin
                 (push s 1st)
                 (if (and (pair? top)(pair? (cdr top)))
                    (push (cdr top) rest))
              )
           )
          )
       )
      (set! env (cdr env))
   )
   (while  (and (pair? rest) (eq? (car rest ) ()))
       (set! rest (cdr rest)))  ;;;;  (())---> ()
   (cons 1st rest)
))

(define (take-include-pat pat env)
   (set! *temp-subenv* ())
   (take-include-pat-sub pat env )
   *temp-subenv*
)

(define (take-include-pat-sub pat env )
   (let ((s 0))
     (if (pair? pat)
       (begin
          (set! s (car pat))
          (cond ((eq? s '...)
                    (take-include-pat-sub (cadr pat) env ))
                ((eq? s 'pat)
                   (take-include-symbol  (cadr pat)  env ) )
                ((or (eq? s 'macro)(eq? s 'literal)(eq? s 'local)
                     (eq? s 'template)(eq? s 'special)(eq? s 'syntax-macro))
                    ()
                   )
                (else 
                    (take-include-pat-sub s env ) 
                    (take-include-pat-sub (cdr pat) env )
               )
          )
       )
      ()
    )
))
#|
(define (take-include-pat-aux pat env level)
  (if (eq? (car pat) 'pat)
        (take-include-symbol (cadr pat) env level)
        (begin
          (take-include-pat-sub (car pat) env level)
          (take-include-pat-sub (cdr pat) env level)
        )
   )
)
|#
(define (take-include-symbol s env )
  (let* ((data 0)(x 0))
    ;;; (format #t "~s ~s ~s~%" s env level)
    (while (pair? env)
      (set! data (car env))
      (set! env (cdr env))
      (if (pair? data)
         (begin
           (set! x (car data))
           (while  (pair? x)
              (set! x (car x)) 
              ;;;(set! level (- level 1))
           )
           (if (eq? s x) 
             (begin
                (push data *temp-subenv*)
                (set! env ())
             )
           )
         )
       )
    )
))     
                  
;;;; template expand
;;;;
(define (template-exp temp form)
  (set!  *template-name-change* ())
  (get-temp-dotenv temp)
  (template-expand temp *match-data* *temp-dotenv*)
)

(define (find-alias-name name alias)  ;;;; 04.4.17 New
  (let ((d (assq name *template-name-change*)))
    (if d 
       (cdr d)
      (begin
         (if (assq alias *local-env*)  
              ;;; already used alias outside
             (begin
                (set! d (gensym))
                (push (cons name  d) *template-name-change*)
                (symbol-value-set d (symbol-value alias)) ;;; 4.18 for compiler
                 d
              )
             (begin
                 (push (cons name alias) *template-name-change*)
                 alias
             )
          )
        )
     )
))

(define (template-expand temp env dot-env)
  (if (not (pair? temp))
       temp
    (let* ((top (car temp)) (as 0)(s 0)(obj 0))
      (cond ((eq? top 'pat) 
                 (set! top (assq (cadr temp) env))
                 (if top (cdr top) 
                     ;(set! *stop-expand*  #t )
                      *stop-expand*
                 )     )
            ((eq? top 'macro) (cadr temp))
            ((eq? top 'literal) (cadr temp))
            ((eq? top 'local)
                    (set! s (cadr temp))
                    ;;; local is not free and use always alias
                    ;;;   4.18
                    ;;;(set! as (assq s *local-env*))
                    ;;;(if (eq? as (cadddr temp))
                    ;;;     s
                        (begin
                         (set! as (caddr temp))   ;;; alias
                         ;;;(set! as (find-alias-name s (caddr temp)))
                         (push (cons s as) *name-change*)
                         (push (cons as s) *alias-name*)
                         as
                        )
                    ;;;; )
                )
                 ;;;;   (cadr temp)) ;;; toriaezu
            ((eq? top 'template) 
                   ;;;  free var uses alias   4.18
                    (set! s (cadr temp))
                    ;;;(if (assq s *local-env*)
                        (begin
                           ;;;(set! as  (caddr temp))   ;;; alias
                         (set! as (find-alias-name s (caddr temp)))
                           (push (cons as s) *alias-name*)
                            as   ;;; alias
                        )
                   ;;;      s
                   ;;;  )
                )
                  ;;; (cadr temp)) ;;; toriaezu
            ((eq? top 'special)
                    ;;;(format #t "special temp ~s local-env ~s~%" temp *local-env*)
                    (set! s (cadr temp))
                    (set! obj (symbol-value s))
                    (set! as (caddr temp))   ;;; special-object
                    (if ( or (assq s *local-env*) (not (eq? as obj)))
                         (begin
                           (push (cons as s) *alias-name*) ;;;; 
                            as   ;;; special-object
                         )
                         s
                     )
                 )
                ;;; (caddr temp)  ;;; toriaezu
            ((eq? top 'syntax-macro) 
                   (set! s (cadr temp))  ;;; original name
                   (set! obj (cadddr temp))   ;;; def
                   (set! as (get-macro s))
                   (if (and (eq? as obj) (not (assq s *local-env)))
                         s
                     (begin 
                        (set! s (caddr temp))
                        (if (not (eq? as obj)) 
                           (set! *macro-bind-local* 
                               (cons (cadr (cadddr temp)) *macro-bind-local* ))
                        )
                       (push (cons s (cadr temp)) *alias-name*)
                       s
                     )
                    )
                 )
                  ;;; (caddr temp))    ;;; this is alias ! (see pat-trans.ss ) toriaezu  
                   ;;; (cadr temp))    ;;; toriaezu  
                   ;;;  (cons macro (caddr temp)))  ;;; toriaezu
            ((eq? top 'vector)
                 (set! s (template-expand (cddr temp) env dot-env))
                 (list->vector s)
               )
            ((not (pair? top))
                (set! s (template-expand (cdr temp) env dot-env)) 
                (if (eq? s *stop-expand*)
                    ;;;(cons top ())  ;;;; ????
                    s    ;;;04 4.22
                    (cons top s)   )
                   )
            ((eq? (car top) '...)
                (template-dot-exp (cadr top)  (cdr temp) env dot-env)  )
            (else
                (set! s   (template-expand (cdr temp) env dot-env) )
                (if (eq? s *stop-expand*) 
                    (begin
                       ;;;(format #t "stop expand temp ~s~%" temp)
                        s
                    )
                    (begin
                       (if (eq? s *null-dot*)
                           ;;;  (set! s ())
                            s ;;;;  04.4.22
                       )
                       (set! as (template-expand top env dot-env))
                       (if (eq? as *stop-expand*)
                            as    ;;;;  ???  s
                          (if (eq? as *null-dot*)
                            s
                            (cons as s)
                          )
                       )
                    )
               )
               ;;(cons (template-expand top env dot-env)
               ;;      (template-expand (cdr temp) env dot-env) )
            )
        )
     )
  )
)
 
(define (template-dot-exp pat rest env dot-env)
   (let ((1st 0)  (stack ()) (res ())  (ans 0) (stop #f)) 
       ;;(format #t "template-dot-exp  pat ~s rest ~s env ~s dot-env ~s~%"
       ;;             pat rest env dot-env) 
       ;;;(set! *stop-expand* #f)
       (if (pair? rest) (set! res (template-expand rest env dot-env)))
       ;;;(set! *stop-expand* #f)
      (while  (pair? dot-env)  
        (set! 1st (take-1st pat dot-env))
        (set! dot-env (cdr 1st))
        (set! 1st (car 1st))
        (if (pair? 1st)
           (begin
              (set! ans (template-expand pat 1st 1st) )
       ;;;(format #t "template-dot-exp  ans ~s ~%" ans)
               (if  (or (eq? ans *stop-expand*)(eq? ans *null-dot*))
                  (begin
                   (set! dot-env ())
                   (if (null? stack)
                       (set! stop *null-dot*)
                   )
                   ;;;(set! *stop-expand* #f)
                  )
                   (push ans stack)
               )
           )
         )
      )
     (while (pair? stack)
        (set! res (cons (car stack) res))
        (set! stack (cdr stack))
     )
   ;;; res   ;;;;????  *stop-expand????
   ;;; (format #t "template-dot-exp res ~s~%" (if stop stop res))
   ;;;(if stop stop res)    ;;; New!!!
    res
))
       

#| test
  (define temp (template-trans ' (letrec
       ((loop
           (lambda (var ...)
             (if test
                 (begin
                   (if #f #f)
                   expr ...)
                 (begin command ...
                   (loop (do "step" var step ...)
                       ...)
                 )
              )
            )
           ))
        (loop init ...))      ())
  )

  (get-temp-dotenv temp)
  (define env *temp-dotenv* )
  ;;(define s (take-1st env))

  ;;; bug  ---> OK
    (define def (assq 'do *macro-bind*))
   (macro-ex '(do ((i 7)(j 88 (+ j 1))) ((= i 888) foo) goo doo) def)
   (s  '(do ((i 7)(j 8 (+ j 1))) ((= j 80) (write 'end)) (set! i (+ i j)) (write i)) )
  
   (s  '(do ((i 7(+ i 3))(j 88 (+ j 1))) ((= i 888) foo) goo doo) )

   (s '(or))
   (s '(or x (> y 9) ))
   ;;
   (s '(let ((temp 'foo))  (pop x) (write temp)) )
  ;; bug
   (s ' (do ((var 0) (temp lis (cdr temp)))
           ((null? temp))
           (set! var (car temp))
           (write var)
           (write "why"))    )

    (macro-ex ' (do ((var 0) (temp lis (cdr temp)))
           ((null? temp))
           (set! var (car temp))
           (write var)
           (write "why"))   def  )

      (s ' (do ((i 999 (+ i 1)) (var 0) (temp lis (cdr temp)))
           ((null? temp))
           (set! var (car temp))
            (inc i)
           (write var)
           (write "why"))    )
      

  

|#


