;;;  04.4.2
;;;  get-data from *match-dot-data*
;;;

;;;  level =1 ,2, ...
;;;      1 means (... x)   2 means (... (... x))

(define (get-dot-data x level)
  (let* ((p (list '... x)) (env *match-dot-data*))
     (while (> level 1)
        (set! p (list '... p))
        (set! level (- level 1))
      ) 
    (if (pair? env)
          (get-dot-data-main p env)
        ()
    )
))

(define (get-dot-data-main p data)
     (set! data (find-dot-data p data))
     (if (pair? data)
          (get-dot-env (cadr p) (cdr data))
          ()
     )
)

(define (find-dot-data p data)
  (let* ( (top 0)(ans #f))
      (if (pair? data)
          (begin
             (set! top (car data))
             (if (and (pair? top ) (eq? (car top) 'dot...))
                 (if (member p top)
                       data
                      #f
                 )
                (begin
                  (set! ans (find-dot-data p (car data)))
                  (if ans ans
                        (find-dot-data p (cdr data))
                  )
                )
             )
          )
         #f
       )
))

(define  (get-dot-env p data)
 (let* ((ans #f))
   ;;; (format #t "get-dot-env p ~s data ~s~%" p data)
   (if (symbol? p)
         (cons p  (map (lambda (x)(dot-symbol-data  p x)) data) )
         (map (lambda (x) (get-dot-data-main  p x)) data)
   )
))
 
(define (dot-symbol-data p data)
   ;;; (format #t "dot-symbol-data p  ~s data ~s~%" p data)
      (if (eq? p (car data))
               data
             (begin
               (set! data (assq p data))
               (if data data ())
             )
         )
)


