;;; match-linear.ss
;;;  05.10.16
;;;;
;;;   p  is linear

(define  (match p f env)
   (S-read-init f)
   (match-gen  p env ())
)

(define (match-gen p  env res)
     ;;;(format #t "match-pair ~s ~s ~%" p f)
   (if (pair? p)
         (match-exec (car p)(cdr p) env res)
      (if (null? p)
           res
          (if (equal? p (S-read))
                res
                #f
           )
      )
  )
)

(define (match-pair p  env res)
     ;;;(format #t "match-pair ~s ~s ~%" p f)
   (if (null? p)
       res
     (match-exec (car p)(cdr p) env res)
  )
)
 
(define (match-exec x rest env res)
     ;;;(format #t "match-exec  x ~s rest ~s res ~s~%" x rest res)
   (if (pair? x)
        (if (eq? (car x) '...)
              (match-exec-dot  x rest  env res)
             (begin
               (set! res  (match-exec-pair  x  env res))
               (if res
                     (match-pair rest env res)
                      #f
                )
             )
        )
        (if (equal? (S-read) x)
             (match-pair rest env res)
             #f
       )
   )
)

(define (match-exec-pair  x  env res)
   (let* ((top (car x)) (v 0) (end #f))
     ;;;;(format #t "exec-pair x ~s  res ~s~%" x  res)
     (cond ((eq? top 'pat )
               (set! v (S-read))
               (if (eof-object? v)
                    #f
                  (cons (cons (cadr x) v)  res) 
               )
             )
           ((eq?  top 'macro)
               (set! v (S-read))
                (if  (eq? v (cadr x))
                     res   #f
               ) 
             )
           ((eq?  top 'literal)
               (set! v (S-read))
               (if (eq? (cadr x) v)
                  (if  (eq? (assq  v env)  (caddr x))
                        res
                        #f
                  ) 
                #f
               )   
             )
           (else
              (set! v (funcall top))  ;;;; S-read-left etc.
              (if v res #f)
           )
      )
))

(define (match-exec-dot x rest env res)
   (let* ((ans 0) (now (S-read-get)) )
       (set! res (cons x res))
    ;;;; (format #t "exec-dot  x ~s rest ~s res ~s~%" x rest res)
        (set! ans (match-exec-dot-go   x rest env res))
     ;;;(format #t "exec-dot   ans2  ~s ~%"  ans2)
        (if ans
              ans
              (begin
                     (S-read-set now)
                     (set! res (cons (cons :end x)  res))
                    (match-pair rest env res)
               )
        )
))

;;; try  ONE!!!  Back track
(define (match-exec-dot-go  x rest env res)
   (let* ((ans  res) (ans2 0) (now (S-read-get)) )
           (set! ans (match-gen (cadr x) env res))
           (if ans
              (begin
                 (set! now (S-read-get))
                 (set! ans2 (match-exec-dot-go  x rest env ans))
                 (if ans2
                      ans2
                     (begin
                       (S-read-set now)
                       (set! res (cons (cons :end x)  ans))
                       (match-pair rest env res)
                     )
                  )
              )
              (begin
                     (S-read-set now)
                     (set! res (cons (cons :end x)  res))
                     (match-pair rest env res)
               )
           )
))

            
                  
                  
          

