;;;  2010.7.10  psyntax
;;;  2010.7.27  psyntax2.ss
;;;;

(define *macro-bind* ())
(define *syntax-binds*  ())
(define *local-syntax*  #f)

;;;;  yet, fender is not supported
 (define-macro ( syntax form)
     (set!  form (template-trans form))
     `(template-exec ',form)
 )

(define (pre-expand-rules rules)
  (let* ((last (cons ()())))
     (if (pair? rules)
         (pre-expand-rules-aux rules last)
     )
    (cdr last)
))
(define (pre-expand-rules-aux rules last)
  (let* ((rule 0)(pat 0)(temp 0)(fender #t))
         (set! rule (car rules))
         (set! pat  (s->pat (car rule)))
         (if (null? (cddr rule))
               (set! temp (cadr rule))
             ;;;;fender
               (begin
                   (set! fender  (cadr rule))
                   (set! temp (caddr rule))
               )
         )
        (set-cdr! last (cons (list pat fender temp) ()))
       (if (pair? (cdr rules))
             (pre-expand-rules-aux (cdr rules) (cdr last))
       )
))

 (define-macro ( syntax-case-transformer  lite . rules)
   (let* ((form 0)(ans #f)(rule 0)(memo 0))
       (set! *literal* lite)
       (set!  rules (pre-expand-rules rules))
       (set! memo rules)
       (lambda (exp)
          (set! ans #f)
          (set! rules memo)
         (while (and (not ans) (pair? rules))
           (set! rule (car rules))
           (set! ans (s-match (car rule) exp))
           (if ans (set! ans (eval (cadr rule)())))  ;;; fender
           (if ans
               (set! form (eval (caddr rule)()))
           )
           (set! rules (cdr rules))
         )
        (if ans  form (error E_illegal exp))
       )
)) 

(define-macro ( syntax-case exp lite . clauses)
   `((syntax-case-transformer ,lite ,@clauses)
          ,exp)
 )

;;;;   see P192, DYBVIG
(define-macro (syntax-rules-trans x)
       (syntax-case x
          (syntax syntax-case *macro-key* *macro-env* *local-env* y )
          ((_ (i ...) ((keyword .  pattern) template )...)
             (syntax
               (let* ((macro-key *macro-key*)
                 (syntax-env   *local-env*
                   ))  
                 (lambda (y) 
                    (set! *macro-env* syntax-env)
                    (set! *macro-key* macro-key)
                    (syntax-case y (i ...)
                       ((_ . pattern)(syntax template)) ...))
               )
             )
      ))   
)

(define-macro (define-syntax key syntax-rules)
    `(let* ((transformer ())(key-macro ())
               (macro-bind *macro-bind*)(memo ()))
          (set! *macro-key* ',key)
          (set! transformer (eval (syntax-rules-trans ,syntax-rules) ()))
          (set! key-macro  
               (macro x (set! *key-macro* key-macro)
                        (set! memo *macro-bind*)
                        (set! *syntax-loads* ())
                        (set! x (transformer (cons ,key x)))
                        (set! *macro-bind* memo)
                        (set! *macro-key* #f)
                        x
                )
           )
          (set! *macro-bind* (cons (cons ',key 
               (cons key-macro (cons  transformer ())))
                   *macro-bind*))
          (push (cons *macro-key* *macro-env*) *syntax-binds*) 
             ;;;;  (key  key-macro  transformer )
          (set! *macro-key* #f)
          ',key
     )
)
;;(trace template-trans)
(define-syntax syntax-environment
  (syntax-rules ()
      ((_  () form) form)
      ((_  ((alias var key) ...) form)
            (let* ((alias (syntax-load (quote var ) (quote key))) ...)
                 form
            )
        )
   )
)
(define-syntax let-syntax-environment
  (syntax-rules ()
      ((_  () form) form)
      ((_  ((alias var key) ...) form)
            (let* ((alias var) ...)
                 form
            )
        )
   )
)


(define (syntax-load var key)
    (let* ((x (assq key *syntax-binds*)))
       (if (null? x )
              (error E_illegal key)
           (begin
              (set! x (assq var (cdr x)))
              (if x
                  (cdr x)
                  (error E_illegal var)
              )
           )
       )
))

;;;;
#|
(define-syntax let-syntax-transformer 
   (syntax-rules (define-syntax)
       ((_ ((key  exp)...))
              (let*  ((temp *macro-bind*)(env (interaction-environment)))
                (set! *macro-bind* ())
                (define-syntax key exp) ...
                (lambda (x)  
                   (set! *local-syntax* #t)
                   (set! x (syntax-expand  x env)) 
                   (set! *macro-bind* temp)
                   (set! *local-syntax* #f)
                    x
                ))
         ) 
      )
)
|#
(define-macro (let-syntax key-exp . forms)
     (let*  ((env (interaction-environment))(form ()))
         (set! *syntax-loads* ())
           (set! form  (eval (syntax-expand
             `((let-syntax-transformer ,key-exp) '(begin ,@forms))
              env) ()) ) 
            (set! form `(let-syntax-environment
                ,*syntax-loads* ,form))
            (set! *syntax-loads* ())
            form  
     )
 )

#|
(define-macro (let-syntax key-exp . forms)
     (let*  ((env (interaction-environment)))
            (syntax-expand
             `((let-syntax-transformer ,key-exp) '(begin ,@forms))
             env) 
     )
 )
|#

