;;;; quasiquote
;;;  2010.8.12  revised
;;;
(define-syntax quasiquote
 (lambda (x)
    (quasi-sub (cadr x))
 )
)
(define (quasi-sub  x)
     (if (pair? x)
           (quasi-pair x)
          (if (symbol? x)
                 (list 'quote x)
                 x
          )
     )
)

(define (quasi-pair x)
   (let* ((a (car x)) (b (cdr x)))
      (if (pair? a)
         (if (eq? (car a) 'unquote-splicing )
             (if (null? b)
                    (cadr a)
                    (list 'append (cadr a) (quasi-sub b))
             )
            (list 'cons (quasi-sub a) (quasi-sub b))
         )
       (if (eq? a 'unquote) 
             (car b) 
            (list 'cons (quasi-sub a) (quasi-sub b))
       )
     )
))

            

       
       
