;;;;  only for special form
;;;;  2010.8.19 revised
;;;;       8.23  named let
;;;           

(in-package "macro")

(define-syntax special-syntax  
   (lambda (x)
      (syntax-case x   (define-syntax syntax-rules syntax)
  ((_ key  (syntax-rules  lite
     ( pat1 temp1) (pat2 temp2) ...) )

     (let* ((keyword (syntax key)) ( al (special-alias keyword)))
        `(define-syntax ,keyword 
            (syntax-rules 
              ,@(syntax (lite 
              (pat1 temp1)
              (pat2 temp2) ...
              )
             )  
           ((_   v  ...) (,al  v  ...))
           )
         )
     ) 
  )
   )
))

(special-syntax  define (syntax-rules ()
   ((define (f . x) b ...)
     (define f (lambda x b ...))  )
   )
)

(define-syntax  let-define 
   (syntax-rules (begin define )
  ((_  (define (f .  x) c ... )    b ...)
     (let-define 
         ("define-symbol"  f (lambda x c ...)) b ...))
  ((_ (define f c ) b ...)
     (let-define
              ("define-symbol"  f c ) b ...))
  ((_  ("define-symbol"  a b) ("define-symbol"  x init) ...
                     (define (g . y) c ...)  body ...) 
     (let-define  ("define-symbol"  a b) ("define-symbol"  x init) ...  
              ("define-symbol"  g (lambda y c ...)) body ...))
  ((_ ("define-symbol"  a b) ("define-symbol"  x init) ...
                     (define g  c )  body ...)
     (let-define ("define-symbol"  a b) ("define-symbol"  x init) ...  
              ("define-symbol"  g c ) body ...) )
  ((_  ("define-symbol"  a b) ("define-symbol"  x init) ...  body ...)
       (alias:letrec ((a b) (x init) ...)
           body ...))   
  )
)

(define-syntax let*
   (syntax-rules (begin define )
    ((let* args  (define . v) ... (begin c ...) w ... )
     (let* args  (define . v) ... c ... w ...))
    ((let* args  (define a .  b)  v ...)
       (alias:let* args (let-define  (define a . b) v ...)))
    ((let* args  v ...)
       (alias:let* args  v ...))
))

(define-syntax letrec
   (syntax-rules (begin define )
    ((_ args  v ... (begin c ...) w ... )
     (letrec args v ... c ... w ...))
    ((_ args  (define a b ...) v ...)
       (alias:letrec args (let-define  (define a b ...) v ...)))
    ((_ args  v ...)
       (alias:letrec args  v ...))
))

(define-syntax let
  (lambda (x)
   (syntax-case x (define begin)
     ((_ f ((x v) ...) e ...)
        (identifier? (syntax f))  ;;; named let fender
        (syntax ((letrec ((f (lambda (x ...) e ...)))f) v ...)))
    ((_ args  v ... (begin c ...) w ... )
      (syntax (let args v ... c ... w ...)))
    ((_ args  (define a b ...) v ...)
       (syntax (alias:let args (let-define  (define a b ...) v ...))))
    ((_ args  v ...)
       (syntax (alias:let args  v ...)))
)))


(define-syntax lambda
   (syntax-rules (begin define )
    ((_ args  v ... (begin c ...) w ... )
     (lambda args v ... c ... w ...))
    ((_ args  (define a b ...) v ...)
       (alias:lambda args (let-define  (define a b ...) v ...)))
    ((_ args  v ...)
       (alias:lambda args  v ...))
))

#|
(define-syntax let-syntax
  (syntax-rules (begin define )
  ((_  args  v  ... (begin a ...) b ...)
     (let-syntax args v ... a ... b ...))
  ((_ args (define a b ... ) v ...)
       (alias:let-syntax args (let-define  (define a b ...) v ...)))
  ((_ args  v ...)
       (alias:let-syntax args  v ...))
  )
)
(define-syntax letrex-syntax
  (syntax-rules (begin define )
  ((_  args  v  ... (begin a ...) b ...)
     (letrec-syntax args v ... a ... b ...))
  ((_ args (define a b ... ) v ...)
       (alias:letrec-syntax args (let-define  (define a b ...) v ...)))
  ((_ args  v ...)
       (alias:letrec-syntax args  v ...))
  )
)

|#

#|
 (s '(let* ((x 5))
         (define foo (lambda (y) (bar x y)))
         (define bar (lambda (a b) (+ (* a b) a)))
         (foo (+ x 3)) ))

 (s '(let* ((x 5))
         (define (foo y) (bar x y))
         (define (bar a b) (+ (* a b) a))
         (foo (+ x 3)) ))

(let* ((x 5))
         (define (foo y) (bar x y))
         (define (bar a b) (+ (* a b) a))
         (foo (+ x 3)) )
;;;; 45
|#

