;;;; R5RS 6.4
;;;   04.1.5

(define force (lambda(x) (x)))

(define-macro (delay ex)
   `(make-promise (lambda() ,ex))
)

(define make-promise
    (lambda(proc)
      (let* ((ready? #f)(result #f))
         (lambda()
            (if ready?
                 result
                (let* ((x (proc)))
                  (if ready?
                       result
                      (begin
                         (set! ready? #t)
                         (set! result x)
                         result)
                   )
                 )
              )
           )
         )
     )
)

#| check OK
 (define p (delay (begin (set! count (+ count 1))
            (if (> count x)
                 count
                 (force p)))))
 (define x 5)
 (force p)
|#

 
