
;;;tracevar.ss
;;;  2004.7.20
(in-package "trace-var")

(define (trace_var_cmds  x )
   (let* ((var (string->symbol x)))
     ;;;(format #t "var ~s ~%" x var)
      (set! x (assq var *trace-vars*))
     (when x
        (set! x (cdr x))
        (while (pair? x)
           (eval (pop x))
        )
     )
 ))

;;;(if (symbol-bind? 'tcl)
(if *tcl-version*
   (tcl  (tk-string "proc trace_var_cmds {x y z } {upvar $x trace_var" #\newline
    "ss " (obj-address trace_var_cmds) " 0 $x }"))
)
#|
  ;;;koremo ugoku!
 (define cmd (tk-string "proc print_tracevar {x y z } {upvar $x trace_var" #\newline
    "puts \"trace: tklink var  $x <-  $trace_var \" }"))

 (tcl cmd)
 (tklink 'x 0)
 (tcl "trace variable x w print_tracevar")
|#

;; thunk will be executed if the value of symbol is changed
(define (trace-var symbol thunk)
    (let* ((cmds ()) (x 0))
      (set! x (assq symbol *trace-vars*))
      (if x 
           (set-cdr! x (cons thunk(cdr x)))
           (push (cons symbol (cons thunk ())) *trace-vars*)
      )
    (when (and (not x) (symbol-bind? 'tklink?))
         (if (tklink? symbol) 
              (tcl (tk-string "trace variable " symbol " w trace_var_cmds"))
         )
    )
))

(define (untrace-var symbol )
   (let* ((x 0))
      (set! x (assq symbol *trace-vars*))
      (if x
           (set! *trace-vars* (remove x *trace-vars*))
      )
    (when (symbol-bind? 'tklink?)
         (if (tklink? symbol)
              (tcl (tk-string "trace vdelete " symbol " w trace_var_cmds"))
         )
    )
))

(export '(trace-var untrace-var))
(use-package "trace-var" "ss")
