;;; proj.scm
;;;   7.26
;;;

(define pi 3.1415926539897932)

(define *axmin* 0)
(define *aymin* 0)
(define  *azmin* 0)
(define *axmax* 0)
(define *aymax* 0)
(define *azmax* 0)
(define *xunit* 0)
(define *yunit* 0)
(define *zunit* 0)

(define *comm* #f)   ;;;comment ID

(define *comment* "Figure")


;;;  axis
(define (line-wide  pos1 pos2 color  width)
  (set! *color* color)
  (set! *linewidth* width)
 (compute_picture  (list pos1 pos2)())
)

 
(define (write-axis)
  (let ((pos1 0)(pos2 0) (xc 0)(yc 0)(zc 0))
    (set! xc (opt-center *axmin* *axmax*))
     (set! yc (opt-center *aymin* *aymax*))
     (set! zc (opt-center *azmin* *azmax*))
    (set! pos1 (list *axmin*  yc zc))
    (set! pos2 (list *axmax*  yc zc))
    (line-wide  pos1 pos2 '(0.2 0 0)  2)
    (apply put-string  "X" (scale-tr (list  *axmax* yc zc)))
    (apply put-string  "Y" (scale-tr (list  xc *aymax*  zc)))
    (apply put-string  "Z" (scale-tr (list  xc yc *azmax* )))
    
    ;         :anchor 'se :font '(courier 14) :tags '(line move text))
    (memori  pos1 *axmin* 'w)
    (memori pos2 *axmax* 'ne)
    (set! pos1 (list xc  *aymin*  zc))
    (set! pos2 (list xc  *aymax*  zc))
    (line-wide  pos1 pos2 '(0 0.2 0) 2)
    ; (.can.c0 'create 'text (car pos2)(cdr pos2) :text  " Y "
    ;        :anchor 'se :font '(courier 14) :tags '(line move text))
     (memori pos1 *aymin* 'e)
    (memori pos2 *aymax* 'nw)

    (set! pos1 (list xc  yc *azmin*  ))
    (set! pos2 (list xc  yc *azmax*  ))
    (line-wide  pos1 pos2 '(0 0 0.2) 2)
    ; (.can.c0 'create 'text (car pos2)(cdr pos2) :text  " Z "
    ;         :anchor 'se :font '(courier 14) :tags '(line move text))
      (memori pos1 *azmin* 'znw)
    (memori pos2 *azmax* 'sw)

     ;;;(.can.c0 'create 'text 200 780  :text  *comment*  :fill 'black
    ; (write-comm  (/ *width* 2) (- *height* 20))
     ;(.can.c0 'focus 'text)
     ;      (.can.c0 'create 'text (* *width* 0.8) (- *height* 16)
     ;      :text (tk-string "p:" *phi-deg*)  :fill 'black
     ;      :tag '( line move text)    :anchor 'sw :font '(courier 14) )
     ;;;(.can.c0 'bind 'move "<Button-1>" (lambda ()(pos-move))) 
     ;(.can.c0 'bind 'text "<Button-3>" (lambda (x y)(change-text x y))) 
     ; (.can.c0 'bind 'text "<Button-2>" (lambda (x y)(change-font x y)))
 )) 
(define (write-comm x y)
    (if *comm* (.can.c0 'delete *comm*))
    (set! *comm* (.can.c0 'create 'text  x y
           :text  *comment*  :fill 'black
       :tags  '(text line move) :width 550   :anchor 'sw :font '(courier 18) )
    )
)

;(define (comm-move x y)
 ;  (write-comm x y)
;)

(define (memori pos x anc )
  (let ((str (number->string x)) (p (scale-tr pos)))
    (set! p (anchor anc (string-length str) p))
    (apply put-string str  p)
))
(define (anchor anc len pos)
  (let ((x (car pos))(y (cadr pos))(z (caddr pos)))
    (cond ((eq? anc 'w) (set! x (- x (* len 0.05))))
          ((eq? anc 'ne)
              ; (set! x (- x  (* len 0.05)))
                (set! z (- z  0.1))    )
          ((eq? anc 'e) (set! y (- y 0.1)))
          ((eq? anc 'nw) (set! y (+ y 0.1)))
          ((eq? anc 'znw) (set! z (- z 0.1)))
          ((eq? anc 'sw) (set! z (+ z 0.1)))
          (#t)
    )
   (list x y z)
))
           
  


(define (change-text x y )
  (let ((s 0)(id 0)(tags 0)(com 0))
      (set!  id  (.can.c0 'find 'closest x y ) )
      (set! tags (.can.c0 'gettags  id) )
 
        (set! com (.can.c0 'itemcget id :text))
        (set! s (entry-get com ))  ;;*comment*))
        (format #t "~s~%" s)
        (set! *comment* s)
        (if (equal? s "")
          (.can.c0 'delete id)
          (.can.c0 'itemconfigure id  :text s )
        )
 ))
(define (change-font x y )
  (let ((s 0)(id 0)(tags 0)(com 0))
      (set!  id  (.can.c0 'find 'closest x y ) )
     ;; (set! tags (.can.c0 'gettags  id) )
        (set! com (.can.c0 'itemcget id :font))
        (set! s (entry-get com ))  ;;*comment*))
        (format #t "~s~%" s)
        (set! *comment* s)
        (.can.c0 'itemconfigure id  :font s )
))
(define (data-bound data)
  (let ((xmin 1.0e40)(xmax  -1.0e40)
        (ymin 1.0e40)(ymax -1.0e40)
        (zmin 1.0e40)(zmax -1.0e40) (x 0))
    (do ((x 0)(y 0)(z 0) (lis 0))
        ((null? data))
        (set! lis (pop data))
       (do ((d 0))
           ((null? lis))
           (set! d (pop lis))
           (set! x (pop d))
            (set! y (pop d))
            (set! z (car d))
           (if (< x xmin) (set! xmin x))
            (if (> x xmax) (set! xmax x))
           (if (< y ymin) (set! ymin y))
            (if (> y ymax) (set! ymax y))  
           (if (< z zmin) (set! zmin z))
            (if (> z zmax) (set! zmax z))  
        )
    )
  ;(list xmin xmax ymin ymax zmin zmax)
   (set! x (opt xmin xmax))
   (set! *xunit* (pop x))
   (set! *axmin* (pop x))
   (set! *axmax* (pop x))
   (set! x (opt ymin ymax))
   (set! *yunit* (pop x))
   (set! *aymin* (pop x))
   (set! *aymax* (pop x))
   (set! x (opt zmin zmax))
   (set! *zunit* (pop x))
   (set! *azmin* (pop x))
   (set! *azmax* (pop x))
))
(define (screen-size data)
  (let ((wx 0) (xmin 0)(xmax 0)(ymin 0)(ymax 0)
           (xmin2 0)(xmax2 0)(ymin2 0)(ymax2 0))
   ;;
   ;(view xmin2 xmax2 ymin2 ymax2) 
   (clear)
    (data-bound data)
   ;(write-axis )
   ()
))
;;;;  memori wo tukeru
;;;;
(define (log10 x)
  (/ (log x)(log 10)))

(define (opt x1 x2)
  (let ((x (- x2 x1))(n 0) (unit 0) (y2 0)(y1 0))
     (set! n (floor (log10 x)))
     (set! unit (* (expt 10 n) 0.5))
     (set! y2 (* unit (floor (/ x2 unit))))
     (set! y1 (* unit (floor (/ x1 unit))))
     (if (< y2 x2) (set! y2 (+ y2 unit)))
     (if (< x1 y1)(set! y1 (- y1 unit)))
     (list unit y1 y2)
))
  
(define (opt-center a b)
    (cond ( (<= (* a b) 0)
             0)
          ((> b 0) a)
          (#t b)
   )
)








