;;;;   make ball data
;;;; only surface
;;;
(define *n* 20)

(define (make-3dm n)
 (let ((mx (make-vector n 0)))
  (do ((i 0(+ i 1))(my 0))
      ((= i n))
      (set! my  (make-vector n 0))
      (vector-set! mx i my)
       (do ((j 0(+ j 1)))
            ((= j n))
            (vector-set! my j (make-vector n 0))
       )
  )
 mx
))

(define *m3* (make-3dm *n*))
  
(define (get3 m i j k)
   (vector-ref (vector-ref(vector-ref m  i) j) k)
)

(define (set3 m i j k obj)
  (let ((mz  (vector-ref(vector-ref m  i) j)))
    (vector-set! mz k obj)
))
(define (square x)
   (* x x)
)

(define (inner-set m )
  (let ((r (/ (- *n* 4) 2)) (c (/ *n* 2)))
     (do ((i 0 (+ 1 i)))
         ((= i *n*))
         (do ((j 0 (+ 1 j)))
         ((= j *n*))
             (do ((k 0 (+ 1 k))(s 0))
                  ((= k *n*))
                  (set! s (+ (square (- i c))  (square (- j c)) (square (- k c))))
                  (if (< s (* r r))
                      (set3 m i j k 1))
             )
        )
     )
))

(define (outer1-set m )
  (let ((r (/ (- *n* 4) 2)) (c (/ *n* 2)))
     (do ((i 0 (+ 1 i)))
         ((= i *n*))
         (do ((j 0 (+ 1 j)))
         ((= j *n*))
             (do ((k 0 (+ 1 k))(s 0))
                  ((= k *n*))
                  (set! s (+ (square (- i c))  (square (- j c)) (square (- k c))))
                  (if (< s (- (* r r) 12))
                        ()   ;;; do nothing
                     (if (= (get3 m i j k)  1)   
                       (outer1-sub m i j k )
                     )
                 )
             )
        )
     )
))
(define (outer1-sub m i j k)
     (outer1-sub2 m (+ i 1) j k)
     (outer1-sub2 m (+ i -1) j k)
      (outer1-sub2 m i (+ j 1)  k)
     (outer1-sub2 m i (+ j -1)  k)
      (outer1-sub2 m i j (+ k 1) ) 
      (outer1-sub2 m i j (+ k -1)  )
)
(define (outer1-sub2 m i j k)
  (and (< i *n*) (< j *n* )(< k *n*) (>= i 0)(>= j 0)(>= k 0)
     (let ((s (get3 m i j k)))
        (if (= s 0 )
             (set3 m i j k 2)
        )
     )
))
 
(define (outer2-set m )
  (let ((r (/ (- *n* 4) 2)) (c (/ *n* 2)))
     (do ((i 0 (+ 1 i)))
         ((= i *n*))
         (do ((j 0 (+ 1 j)))
         ((= j *n*))
             (do ((k 0 (+ 1 k))(s 0))
                  ((= k *n*))
                  (set! s (+ (square (- i c))  (square (- j c)) (square (- k c))))
                  (if (< s (- (* r r) 12))
                        ()   ;;; do nothing
                     (if (= (get3 m i j k)  1)
                       (outer2-sub m i j k )
                     )
                 )
             )
        )
     )
))
(define (outer2-sub m i j k)
     (outer2-sub2 m (+ i 2) j k)
     (outer2-sub2 m (+ i -2) j k)
      (outer2-sub2 m i (+ j 2)  k)
     (outer2-sub2 m i (+ j -2)  k)
      (outer2-sub2 m i j (+ k 2) )
      (outer2-sub2 m i j (+ k -2)  )

      (outer2-sub2  m  (+ i 1) (+ j 1)  k)
     ( outer2-sub2  m  (+ i 1) (+ j -1) k)
     (outer2-sub2  m  (+ i -1) (+ j 1)  k)
     ( outer2-sub2  m  (+ i -1) (+ j -1) k)
       (outer2-sub2  m  (+ i 1) j (+ k 1)  )
     ( outer2-sub2  m   (+ i 1) j (+ k -1) )
     (outer2-sub2  m    (+ i -1) j (+ k 1)  )
     ( outer2-sub2  m  (+ i -1) j (+ k -1) )
        (outer2-sub2  m i  (+ j 1)  (+ k 1)  )
     ( outer2-sub2  m   i (+ j 1)  (+ k -1) )
     (outer2-sub2  m    i (+ j -1)  (+ k 1)  )
     ( outer2-sub2  m  i (+ j -1)  (+ k -1) )
)
(define (outer2-sub2 m i j k)
  (and (< i *n*) (< j *n* )(< k *n*) (>= i 0)(>= j 0)(>= k 0)
     (let ((s (get3 m i j k)))
        (if (= s 0 )
             (set3 m i j k 3)
        )
     )
))
    
(define (out-data m)
    (do ((i 0 (+ 1 i)))
         ((= i *n*))
         (do ((j 0 (+ 1 j)))
         ((= j *n*))
             (do ((k 0 (+ 1 k))(s 0))
                  ((= k *n*))
                  (set! s (get3 m i j k))
                  (if (= s 3)
                      (format #t "~s ~s ~s~%" i j k )     
                 )
             )
        )
      (format #t "s s~%" )
     )
)

(inner-set *m3*)
(outer1-set *m3*)
(outer2-set *m3*)
(out-data *m3*)
(exit)
